﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.33
@EndOfDesignText@
#Event: LinkClicked (URL As String)
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	Type BBCodeTextNode (Text As String, Tags As List)
	Type BBCodeTagNode (Tag As String, Extra As Map, CanHaveNestedTags As Boolean)
	Private Start As Int
	Private AllowedTags As B4XSet
	Private Stack As List
	Private xui As XUI
	Public DefaultBoldFont As B4XFont
	Public DefaultFont As B4XFont
	Public Style As BCParagraphStyle
	Public UrlColor As Int = 0xFF003FFF
	Private mTextEngine As BCTextEngine
	Private mText As String
	Public ForegroundImageView As B4XView
	Public BackgroundImageView As B4XView
	Public Paragraph As BCParagraph
	Public DefaultColor As Int = xui.Color_Black
	Private Runs As List
	Public URLs As Map
	Private TouchPanel As B4XView
	Public Views As Map
	Public sv As B4XView
	Public Padding As B4XRect
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	AllowedTags = B4XCollections.CreateSet2(Array("b", "u", "url", "plain", "color", "img", "view", _
		"vertical", "textsize", "alignment"))
	Dim iv As ImageView
	iv.Initialize("")
	ForegroundImageView = iv
	URLs.Initialize
	Views.Initialize
	If xui.IsB4J Then
		Padding.Initialize(5dip, 5dip, 20dip, 5dip)
	Else
		Padding.Initialize(5dip, 5dip, 5dip, 5dip)
	End If
End Sub

Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	#if B4J
	Dim sp As ScrollPane
	sp.Initialize("")
	sp.SetHScrollVisibility("NEVER")
	#else if B4A
	Dim sp As ScrollView
	sp.Initialize2(50dip, "")
	#Else If B4i
	Dim sp As ScrollView
	sp.Initialize("", mBase.Width, 50dip)
	sp.Bounces = False
	#End If
	sv = sp
	sv.Color = mBase.Color
	sv.ScrollViewInnerPanel.Color = mBase.Color
	mBase.AddView(sv, 0, 0, mBase.Width, mBase.Height)
  	Dim xlbl As B4XView = Lbl
	DefaultColor = xlbl.TextColor
	DefaultFont = xlbl.Font
	Dim event As String
	If xui.SubExists(mCallBack, mEventName & "_linkclicked", 1) Then event = "TouchPanel"
	TouchPanel = xui.CreatePanel(event)
	#if B4J
	Dim fx As JFX
	DefaultBoldFont = fx.CreateFont(Lbl.Font.FamilyName, DefaultFont.Size, True, False)
	InternalSetMouseTransparent(ForegroundImageView)
	#Else If B4A
	DefaultBoldFont = xui.CreateFont(Typeface.CreateNew(Lbl.Typeface, Typeface.STYLE_BOLD), xlbl.TextSize)
	#else if B4i
	DefaultBoldFont = xui.CreateDefaultBoldFont(xlbl.TextSize)
	#End If
End Sub

#if B4J
Public Sub InternalSetMouseTransparent(v As B4XView)
	Dim jo As JavaObject = v
	jo.RunMethod("setMouseTransparent", Array(True))
End Sub
#End If

Private Sub Base_Resize (Width As Double, Height As Double)
	sv.SetLayoutAnimated(0, 0, 0, Width, Height)
	sv.ScrollViewContentWidth = Width
	If Runs.IsInitialized Then Redraw	
End Sub

Public Sub setTextEngine (b As BCTextEngine)
	mTextEngine = b
	
End Sub

Public Sub getTextEngine As BCTextEngine
	Return mTextEngine
End Sub

Public Sub setText(t As String)
	mText = t
	ParseAndDraw
End Sub

Public Sub getText As String
	Return mText
End Sub

Public Sub ParseAndDraw
	Dim pe As List = Parse(mText)
	sv.ScrollViewInnerPanel.RemoveAllViews
	sv.ScrollViewInnerPanel.AddView(TouchPanel, 0, 0, 0, 0)
	sv.ScrollViewInnerPanel.AddView(ForegroundImageView, 0, 0, 2dip, 2dip)
	Runs = CreateRuns(pe)
	Redraw
End Sub

Public Sub Redraw
	Dim Style As BCParagraphStyle = mTextEngine.CreateStyle
	Style.Padding = Padding
	Style.MaxWidth = mBase.Width
	Style.ResizeHeightAutomatically = True
	mTextEngine.DrawText(Runs, Style, Me)
	TouchPanel.SetLayoutAnimated(0, ForegroundImageView.Left, ForegroundImageView.Top, ForegroundImageView.Width, ForegroundImageView.Height)
End Sub


Private Sub Parse (Text As String) As List
	Dim ParsedElements As List
	ParsedElements.Initialize
	Stack.Initialize
	Stack.Add(CreateTagNode("noop"))
	Dim matcher As Matcher = Regex.Matcher("(?<!\[)\[[^\[]+\]", Text)
	Dim LastMatchEnd As Int = 0
	Dim skipUntilEndTag As Boolean = False
	Do While matcher.Find
		Start = matcher.GetStart(0)
		If Start > LastMatchEnd And skipUntilEndTag = False Then
			ParsedElements.Add(CreateTextNode(Text.SubString2(LastMatchEnd, Start)))
		End If
		Dim tag As String = matcher.Match.SubString2(1, matcher.Match.Length - 1)
		If tag.StartsWith("/") Then
			tag = tag.SubString(1).ToLowerCase
			If StackPeek.Tag <> tag Then
				If StackPeek.CanHaveNestedTags = False Then
					Continue
				End If
				Error("Closing tag does not match: " & tag)
				Return Null
			End If
			If skipUntilEndTag Then
				If Start > LastMatchEnd Then
					ParsedElements.Add(CreateTextNode(Text.SubString2(LastMatchEnd, Start)))
				End If
			End If
			StackPop
			skipUntilEndTag = False
		Else
			If StackPeek.CanHaveNestedTags = False Then Continue
			Dim ClosedTag As Boolean = tag.EndsWith("/")
			If ClosedTag Then tag = tag.SubString2(0, tag.Length - 1)
			tag = tag.Trim
			Dim t As BBCodeTagNode = ParseTag(tag)
			If AllowedTags.Contains(t.Tag) = False Then
				Error("Invalid tag: " & tag)
				Return Null
			End If
			StackPush(t)
			If t.Tag = "plain" Then
				Dim n As BBCodeTagNode = StackPeek
				n.CanHaveNestedTags = False
				skipUntilEndTag = True
			End If
			If ClosedTag Then
				ParsedElements.Add(CreateTextNode(""))
				StackPop
			End If
		End If
		LastMatchEnd = matcher.GetEnd(0)
	Loop
	If Text.Length > LastMatchEnd Then
		ParsedElements.Add(CreateTextNode(Text.SubString2(LastMatchEnd, Text.Length)))
	End If
	Return ParsedElements
End Sub

Private Sub ParseTag (tag As String) As BBCodeTagNode
	'[URL]
	'[URL=sdfsdf] or [URL="sdfsdf"]
	'[URL key1="value 1" key2=34]
	If tag.Contains("=") = False Then Return CreateTagNode(tag.ToLowerCase)
	Dim res As BBCodeTagNode = CreateTagNode("")
	res.Extra.Initialize
	Dim i As Int
	Dim last As Int = -1
	Do While i < tag.Length
		Dim c As String = tag.CharAt(i)
		If c = "=" Then
			Dim key As String = tag.SubString2(last + 1, i).ToLowerCase
			If res.tag = "" Then 'option #2
				res.Tag = key
			End If
			Dim i2 As Int
			If tag.CharAt(i + 1) = QUOTE Then
				i2 = tag.IndexOf2(QUOTE, i + 2)
				res.Extra.Put(key, tag.SubString2(i + 2, i2))
			Else
				i2 = tag.IndexOf2(" ", i + 2)
				If i2 = -1 Then i2 = tag.Length
				res.Extra.Put(key, tag.SubString2(i + 1, i2))
			End If
			i = i2
			last = i
		End If
		If c = " " Then
			If res.Extra.Size = 0 Then
				Dim key As String = tag.SubString2(0, i).ToLowerCase
				res.Tag = key
			End If
			last = i
		End If
		i = i + 1
	Loop
	Return res
End Sub

Private Sub StackPop
	Stack.RemoveAt(Stack.Size - 1)
End Sub

Private Sub StackPush (Tag As BBCodeTagNode)
	Stack.Add(Tag)
End Sub

Private Sub StackPeek As BBCodeTagNode
	Return Stack.Get(Stack.Size - 1)
End Sub

Private Sub CreateRuns (Texts As List) As List
	URLs.Clear
	Dim Runs As List
	Runs.Initialize
	For Each TextNode As BBCodeTextNode In Texts
		Runs.Add(TextToRun(TextNode))
	Next
	Return Runs
End Sub

Private Sub TextToRun (Text As BBCodeTextNode) As BCTextRun
	Dim run As BCTextRun = mTextEngine.CreateRun(Text.Text)
	run.TextColor = DefaultColor
	run.TextFont = DefaultFont
	Dim bold As Boolean
	Dim FontSize As Int = DefaultFont.Size
	For i = 0 To Text.Tags.Size - 1
		Dim tag As BBCodeTagNode = Text.Tags.Get(i)
		Select tag.Tag
			Case "u"
				run.Underline = True
			Case "b"
				bold = True
			Case "url"
				Dim url As String
				If tag.Extra.IsInitialized Then
					url = tag.Extra.Get("url")
				Else
					url = Text.Text
				End If
				URLs.Put(run, url)
				run.Underline = True
				run.TextColor = UrlColor
			Case "color"
				Dim clr As String = tag.Extra.Get("color")
				If clr.StartsWith("#") Then
					Dim clrvalue As Int = Bit.Or(0xff000000, Bit.ParseInt(clr.SubString(1), 16))
					run.TextColor = clrvalue
				Else
					Error("Invalid color value: " & clr)
				End If
			Case "img"
				SetImageView(tag, run)
				If tag.Extra.ContainsKey("vertical") Then
					run.VerticalOffset = DipToCurrent(tag.Extra.Get("vertical"))
				End If
				sv.ScrollViewInnerPanel.AddView(run.View, 0, 0, run.View.Width, run.View.Height)
			Case "view"
				run.View = GetView(tag)
				If tag.Extra.ContainsKey("vertical") Then
					run.VerticalOffset = DipToCurrent(tag.Extra.Get("vertical"))
				End If
				sv.ScrollViewInnerPanel.AddView(run.View, 0, 0, run.View.Width, run.View.Height)
			Case "vertical"
				run.VerticalOffset = DipToCurrent(tag.Extra.Get("vertical"))
			Case "textsize"
				FontSize = tag.Extra.Get("textsize")
			Case "alignment"
				run.HorizontalAlignment = tag.Extra.Get("alignment")
		End Select
	Next
	If bold Then
		run.TextFont = xui.CreateFont2(DefaultBoldFont, FontSize)
	Else if FontSize <> DefaultFont.Size Then
		run.TextFont = xui.CreateFont2(DefaultFont, FontSize)
	End If
	Return run
End Sub

Private Sub GetView (Tag As BBCodeTagNode) As B4XView
	Dim id As String = Tag.Extra.Get("view")
	If Views.ContainsKey(id) = False Then
		Error("Missing view: " & id)
	End If
	Dim v As B4XView = Views.Get(id)
	Return v
End Sub

Private Sub SetImageView (Tag As BBCodeTagNode, run As BCTextRun)
	Dim url As String = Tag.Extra.GetDefault("url", "")
	Dim dir As String = Tag.Extra.GetDefault("dir", File.DirAssets)
	Dim filename As String = Tag.Extra.GetDefault("filename", "")
	Dim width As Int = DipToCurrent(Tag.Extra.GetDefault("width", -1))
	Dim height As Int = DipToCurrent(Tag.Extra.GetDefault("height", -1))
	Dim iv As ImageView
	iv.Initialize("")
	#if B4J
	InternalSetMouseTransparent(iv)
	#End If
	Dim xiv As B4XView = iv
	run.View = xiv
	Dim bmp As B4XBitmap
	If url <> "" Then
		Dim j As HttpJob
		j.Initialize("", Me)
		j.Download(url)
		xiv.SetLayoutAnimated(0, 0, 0, width, height)
		Wait For (j) JobDone (j As HttpJob)
		If j.Success Then
			bmp = j.GetBitmap
			bmp = bmp.Resize(width, height, True)
			xiv.SetBitmap(bmp)
		End If
		j.Release
	Else
		If width = -1 And height = -1 Then
			bmp = xui.LoadBitmap(dir, filename)
		Else if width > -1 And height > -1 Then
			bmp = xui.LoadBitmapResize(dir, filename, width, height, False)
		Else if width > -1 Then
			bmp = xui.LoadBitmapResize(dir, filename, width, 10000, True)
		Else
			bmp = xui.LoadBitmapResize(dir, filename, 10000, height, True)
		End If
		xiv.SetBitmap(bmp)
		xiv.SetLayoutAnimated(0, 0, 0, bmp.Width, bmp.Height)
	End If
End Sub


Private Sub Error (msg As String)
	Dim s As String = $"Error (position - ${Start}): ${msg}"$
	#if B4A or B4i
	LogColor(s, Colors.Red)
	#else
	LogError(s)
	#End If
End Sub

Private Sub CreateTextNode(Text As String) As BBCodeTextNode
	Dim n As BBCodeTextNode
	n.Initialize
	n.Text = Text
	n.Tags.Initialize
	n.Tags.AddAll(Stack)
	Return n
End Sub

Private Sub CreateTagNode (Tag As String) As BBCodeTagNode
	Dim n As BBCodeTagNode
	n.Initialize
	n.Tag = Tag
	n.CanHaveNestedTags = True
	Return n
End Sub

Private Sub TouchPanel_Touch (Action As Int, X As Float, Y As Float)
	If Action = TouchPanel.TOUCH_ACTION_UP Then
		Dim single As BCSingleStyleSection = mTextEngine.FindSingleStyleSection(Paragraph, X, Y)
		If single <> Null Then
			If URLs.ContainsKey(single.Run) Then
				Dim url As String = URLs.Get(single.Run)
				CallSubDelayed2(mCallBack, mEventName & "_LinkClicked", url)
			End If
		End If
	End If
End Sub

